#ifndef CALCULATEPRICEDUMMY_H
#define CALCULATEPRICEDUMMY_H


#include <QObject>
#include "CalculatePriceInterface.h"
using namespace nsCalculatePriceInterface;


class CalculatePriceDefault : public QObject,
        public CalculatePriceInterface
{
    Q_OBJECT
    Q_INTERFACES(CalculatePriceInterface)

public:
    CalculatePriceDefault(QObject *parent = 0);
    ~CalculatePriceDefault();

    // interface:
    PLUGIN_STATE initCalculatePricePlugin(QObject *healthEventReceiver, const QSettings & settings);
    void requestCalculatePrice(const QString & AccessInformation,
                               const QString & AccessInformationType,
                               const QString & PermitType);
    void requestCalculatePrice(const QString & AccessInformation,
                               const QString & AccessInformationType,
                               const QString & PermitType,
                               const QString & parktime);
    void requestCalculatePrice(const QString & AccessInformation,
                               const QString & AccessInformationType,
                               const QString & PermitType,
                               nsCalculatePriceInterface::STEP step);
    void requestCalculatePrice(const QString & AccessInformation,
                               const QString & AccessInformationType,
                               const QString & PermitType,
                               int coinValue);
    void requestCalculatePrice(const QString & AccessInformation,
                               const QString & AccessInformationType,
                               const QString & PermitType,
                               const QString & parktime,
                               const QString & cardInfo,
                               const QString & transactionInfo);
    void requestProcessTransaction(const QString & AccessInformation,
                                   const QString & AccessInformationType,
                                   const QString & amount,
                                   bool isOffline,
                                   const QString & TransactionId,
                                   const QString & ReceiptData,
                                   const QString & PermitType,
                                   const QString & PaymentType);


    PLUGIN_STATE getState();
    quint32 getLastError();
    const QString & getLastErrorDescription();

    const QString & getPluginInfo();

    const QString getString(nsCalculatePriceInterface::RESULT_STATE resultState);

signals:
    void requestCalculatePriceResult(RESULT_STATE resultState,
                                  const QString & accessInformation,
                                  const QString & accessInformationType,
                                  const QString & amountDuePeriodStart,
                                  const QString & amountDuePeriodEnd,
                                  const QString & amountDueNet,
                                  const QString & amountDueTax,
                                  const QString & gracePeriod,
                                  const QString & errorCode,
                                  const QString & errorDescription);
    void requestCalculatePriceResult(RESULT_STATE resultState,
                                  const QString & accessInformation,
                                  const QString & accessInformationType,
                                  const QString & amountDuePeriodStart,
                                  const QString & amountDuePeriodEnd,
                                  const PriceInfo & priceInfo,
                                  const QString & errorCode,
                                  const QString & errorDescription);
   void requestProcessTransactionResult(RESULT_STATE resultState,
                                        const QString & errorCode,
                                        const QString & errorDescription);


private:
   quint32 errorCode;
   QString errorCodeString;
   QString errorDescription;
   QString pluginInfo;

   PLUGIN_STATE pluginState;

};

#endif // CALCULATEPRICEDUMMY_H
